.686p
.xmm
.model	flat, stdcall
option	casemap :none   ; case sensitive
.nolist
include windows.inc
inv equ Invoke

soff Macro QuotedText:Vararg	; returns offset to a string
Local LocalText
.data
LocalText db QuotedText,0
.code
EXITM <offset LocalText>
Endm

Desc Macro TextVal:Req	; used in the first line of each test proc (Doit1....Doitxx)
local DescLoc, FirstFlag
.data
FirstFlag dd 0
DescLoc db TextVal,0
.code
	.if FirstFlag==0	; if not first time, just continue
		mov FirstFlag,1	; set done for next time
		mov ebx,offset DescLoc
		call SetDesc
		ret		; if this was the first time, just return without running rest of code
	.endif
endm

Startup macro	; This macro is inserted before each block of test code
	mov Loops,TimesToLoop
	xor eax,eax	; setup to call the EAX=0 version of CPUID to clear pipeline
	mov	[StartingCycle],eax		; just to make sure they are in the cache
	mov	[StartingCycle+4],eax
	align 16	; just to be sure all code starts with equal advantage
	cpuid 		; call the EAX=0 version of CPUID to clear pipeline (serialize) (finish any pending instructions)
	rdtsc
	mov	[StartingCycle],eax
	mov	[StartingCycle+4],edx
TimingLoop = $
endm

Endup macro		; This macro is inserted after each block of test code
	sub Loops,1	; end of test code ----------------------------------------
	jnz	TimingLoop
	rdtsc
	call WrapUp
	ret
endm

Endup2 macro		; This alternate macro is inserted after each block of test code
	sub Loops,1	; note:  no return so additional test prints can be done
	jnz	TimingLoop
	rdtsc
	call WrapUp
endm

msg Macro qtext:VARARG
pusha
invoke MessageBox,0,addr literal(qtext),addr ProgName,0
popa
endm
GetHandle Macro MyId:Req,MyHandle:Req 
    invoke GetDlgItem,hWin,MyId
    mov MyHandle,eax         ; save handle to control
endm

uselib	MACRO	libname
	include		libname.inc
	includelib	libname.lib
ENDM

uselib user32
uselib kernel32
uselib comctl32
uselib gdi32

;uselib shell32
;uselib comdlg32
;uselib masm32
.listall

DlgProc		PROTO :DWORD,:DWORD,:DWORD,:DWORD


TimesToLoop	equ 1000000	; number of times to loop


MaxTests	equ 20		; maximum number of timing tests, increase as desired up to 999

;scratch for tests
.data?
align 4
temp1	dd ?	; aligned
temp2	dd ?
buff db 100 dup (?)

.code
start:
	invoke	InitCommonControls
	invoke	GetModuleHandle, NULL
	invoke	DialogBoxParam, eax, 101, 0, ADDR DlgProc, 0
	invoke	ExitProcess, eax


; -------------------------------  Timing Tests -----------------------------------------


; This is the proc to copy to create new timing tests.  Copy this proc and paste it below.
; Change the X in DoitX to a number (Doit1, Doit2,...Doitxx where xx=MaxTests)
 
DoitX:       ;---------------------------------------------------------------------------
	Desc ' ' ;insert description of this test between single quotes
	; -- place any setup desired here.  Registers will not be preserved into test code --
	Startup	; place test code here between Startup and Endup ----------------------------

	Endup	; end of test code ----------------------------------------------------------


;-------------------------------------- Test Procs --------------------------------
.data
align 16
;db 0	; for testing bad alignment
String1     DB  "Smple String 01234 56789 ABCDEF AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoP",\
                "pQqRrSsTtUuVvWwXxYyZz Now I Know My ABC's, Won't You Come Play.",0,"xyz"
align 16
;db 0
String2     DB  128 dup(0)
xx db 'xyz',0	; for testing results for overflow into next string

tp db 'test print',0
.code


align 16
SzCpy1 proc  uses ebx SzDest:DWORD, SzSource:DWORD
; empty rountine
ret
SzCpy1 endp

;---------------------------------------------------

; 
; The technique used to find the terminating null was adapted
; from the MASM32 STRLEN procedure, which was adapted from an
; algorithm written by Agner Fog.
; 
align 16
SzCpy2 proc uses ebx lpsrc:DWORD,lpdest:DWORD	; MichaelW routine
    mov   eax,lpsrc
    mov   edx,lpdest
    jmp @f
    db 6 dup (0)	;6=160
    ;align 4
    ; 8 nop-s = 160
  @@:
    REPEAT 7                  ; unroll x 8  7=162, 8=171, 6=168, 4=166, 3=188
      mov   ebx,[eax]           ; get next 4 bytes
      add   eax,4
      lea   ecx,[ebx-01010101h] ; subtract 1 from each byte
      not   ebx                 ; invert all bytes     
      and   ecx,ebx             ; and each byte with inversion
      not   ebx                 ; restore bytes
      and   ecx,80808080h       ; bytes=80h for null,otherwise 0
      jnz   @F                  ; jump if zero byte present
      mov   [edx],ebx           ; copy 4 bytes
      add   edx,4
    ENDM
    jmp   @B
  @@:
    mov   [edx],bl              ; move first byte
    add   edx,1
    test  bl,bl
    jz    @F                    ; jump if was null
    mov   [edx],bh              ; move next byte
    add   edx,1
    test  bh,bh
    jz    @F                    ; jump if was null
    shr   ebx,16
    mov   [edx],bl              ; move next byte
    add   edx,1
    test  bl,bl
    jz    @F                    ; jump if was null
    mov   [edx],bh              ; move last byte
  @@:
    mov   eax,edx               ; return length w/o null
    sub   eax,[esp+12]          ; lpdest
    ret
SzCpy2 endp

;---------------------------------------------------
align 16
; Mark Larson's mmx routine 1
SzCpy3 proc near src_str:DWORD, dst_str:DWORD
   mov eax,src_str
   mov esi,dst_str
   
   align 16	;158
   
qword_copy:
   pxor mm1,mm1
   movq mm0,[eax]
   pcmpeqb mm1,mm0
   add eax,8
   pmovmskb ecx,mm1
   or ecx,ecx
   jnz finish_rest
   movq [esi],mm0
   add esi,8
   jmp qword_copy

finish_rest:

   sub eax,8
byte_copy:
   movzx ecx,byte ptr [eax]
   add eax,1
   mov [esi],cl
   add esi,1
   test cl,cl
   jz zero_byte
   jmp byte_copy
zero_byte:
   RET
SzCpy3 endp

align 16
; Mark Larson's mmx routine
SzCpy4 proc near src_str:DWORD, dst_str:DWORD
   mov eax,src_str
   mov esi,dst_str
   
   jmp qword_copy
	db 7 dup (0)	;7=143
	
qword_copy:
   pxor mm1,mm1
   movq mm0,[eax]
   pcmpeqb mm1,mm0
   add eax,8
   pmovmskb ecx,mm1
   or ecx,ecx
   jnz finish_rest
   movq [esi],mm0
   add esi,8
   jmp qword_copy

finish_rest:

   sub eax,8
byte_copy:
   movzx ecx,byte ptr [eax]
   add eax,1
   mov [esi],cl
   add esi,1
   test cl,cl
   jz zero_byte
   jmp byte_copy
zero_byte:
   RET
SzCpy4 endp

align 16
; Mark Larson's mmx routine
SzCpy5 proc near src_str:DWORD, dst_str:DWORD
   mov eax,src_str
   mov esi,dst_str
   
	jmp qword_copy	;159
	align 16

qword_copy:
   pxor mm1,mm1
   movq mm0,[eax]
   pcmpeqb mm1,mm0
   add eax,8
   pmovmskb ecx,mm1
   or ecx,ecx
   jnz finish_rest
   movq [esi],mm0
   add esi,8
   jmp qword_copy

finish_rest:

   sub eax,8
byte_copy:
   movzx ecx,byte ptr [eax]
   add eax,1
   mov [esi],cl
   add esi,1
   test cl,cl
   jz zero_byte
   jmp byte_copy
zero_byte:
   RET
SzCpy5 endp

;----------------------- Testing Routines --------------------------------------  
testprint = 1	; change to 0 to get test print of output

Doit1:       ;---------------------------------------------------------------------------
	Desc 'empty routine, takes 9 cycles on my machine '
	Startup
	invoke SzCpy1, addr String2, addr String1
	Endup
Doit2:       ;---------------------------------------------------------------------------
	Desc 'SzCpy2 by MichaelW, takes 160 on my machine'
	Startup
	invoke SzCpy2, addr String1, addr String2
	if testprint
    	Endup	; comment this line to force test print
	else
	    Endup2	; end of test code ----------------------------------------------------------
	    inv MessageBox,0,addr String2,0,0
	    inv MessageBox,0,addr xx,addr tp,0	
	    ret
	endif
Doit3:       ;---------------------------------------------------------------------------
	Desc 'SzCpy3 by Mark Larson using mmx, align 16 only, runs 158 on my machine'
	Startup
	invoke SzCpy3, addr String1, addr String2
	if testprint
    	Endup	; comment this line to force test print
	else
	    Endup2	; end of test code ----------------------------------------------------------
	    inv MessageBox,0,addr String2,0,0
	    inv MessageBox,0,addr xx,addr tp,0	
	    ret
	endif

Doit4:      ;---------------------------------------------------------------------------
	Desc 'SzCpy4 by Mark Larson using mmx, jmp and db 7 dup (0), runs 149 on my mach'
	Startup
	invoke SzCpy4, addr String1, addr String2
	if testprint
    	Endup	; comment this line to force test print
	else
	    Endup2	; end of test code ----------------------------------------------------------
	    inv MessageBox,0,addr String2,0,0
	    inv MessageBox,0,addr xx,addr tp,0	
	    ret
	endif

Doit5:      ;---------------------------------------------------------------------------
	Desc 'SzCpy5 by Mark Larson using mmx, jmp and align 16, runs 159 on my machine'
	Startup
	invoke SzCpy5, addr String1, addr String2
	if testprint
    	Endup	; comment this line to force test print
	else
	    Endup2	; end of test code ----------------------------------------------------------
	    inv MessageBox,0,addr String2,0,0
	    inv MessageBox,0,addr xx,addr tp,0	
	    ret
	endif



; ------------------------ end of timing tests --------------------





; ----------------- miscellaneous procs for the timing test --------------------

.data
CallTable dd MaxTests dup (0)		; up to MaxTests tests allowed
TableEnd	equ $

ProgName	db 'Timing Test',0
.data?
align 4
StartingCycle dd ?
CyclePart2	  dd ?
hWin        dd ?  ; dialog handle
CurProcess	dd ?
Result		dd ?
Average		dd ?
TestNum 	dd ?
htemp		dd ?
Loops		dd ?
hFnt 		dd ?
.code
DlgProc	proc uses ebx, hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	.if	uMsg == WM_COMMAND
		.if	wParam > 2000 && wParam < 2999 ; one of the test buttons
			pusha
			mov eax,wParam
			sub eax,2000
			mov TestNum,eax	; save the actual test number, 1..999
			invoke GetCurrentProcess
			mov [CurProcess],eax
			invoke SetPriorityClass, CurProcess, REALTIME_PRIORITY_CLASS
			invoke SetProcessPriorityBoost, CurProcess, FALSE	; normal behavior
			invoke SetThreadPriority, CurProcess, THREAD_PRIORITY_TIME_CRITICAL
			mov eax,TestNum
			sub eax,1
			mov eax,[CallTable+eax*4]
			.if eax!=0
				call eax  	; call Doit1 or Doit2 or .... DoitN
			.endif
			invoke SetThreadPriority, CurProcess, THREAD_PRIORITY_NORMAL
			invoke SetPriorityClass, CurProcess, NORMAL_PRIORITY_CLASS
			popa
		.endif
    .elseif uMsg== WM_INITDIALOG
		pusha
        mov eax,hWnd    ; save handle for everyone
        mov hWin,eax
		inv SendMessage,hWin,WM_GETFONT,0,0	; get the font for the controls to use
		mov hFnt,eax

		call CallTableSetup	; go set up the address for the procs to test, add controls, etc.		
		mov ebx,1006	; print out number of times we are looping
		GetHandle ebx,htemp
		invoke wsprintf,addr buff,soff("%i"),TimesToLoop
		invoke SendMessage,htemp,WM_SETTEXT,0,addr buff
		
		popa
	.elseif	uMsg == WM_CLOSE
		invoke	EndDialog,hWin,0
	.endif

	xor	eax,eax
	ret
DlgProc	endp


.data
Wide1 = 50  	; width of Test Button
Wide2 = 212 	; width of Description
Wide3 = 75  	; width of Clock Cycles
Wide4 = 75  	; width of Average Clocks
Wide5 = 75  	; width of scratch
Left1 = 11		; Button   2001, 2002, .... , 2020   
Left2 = Left1+Wide1+4		; Edit 1, Description, will compute location, 3001, 3002, ... , 3020
Left3 = Left2+Wide2+2		; Edit 2, Clock Cycles, 4001, ...
Left4 = Left3+Wide3+2		; Edit 3, Average Clocks 5001, ...
Left5 = Left4+Wide4+2		; Edit 4, Test routine scratch for output value if desired, 6001, ...
TDel  = 32  	; Delta between rows
Top  dd 32	 	; top of all, will increment by TDel
Ht	 dd 32		; height of rows
blank   db ' ',0
edt		db 'EDIT',0,0
CtlGp	dd	2000	; base id

.code
MakeControls proc
	mov eax,2000		; each starts with id 2000+TestNum
	add eax,TestNum
	mov CtlGp,eax
	inv CreateWindowEx,0,soff("BUTTON"),addr buff,
			WS_CHILD or WS_VISIBLE or WS_TABSTOP,
			Left1,Top,Wide1,Ht,hWin,CtlGp,temp1,NULL
	inv SendMessage,eax,WM_SETFONT,hFnt,TRUE
	add CtlGp,1000
	
	inv CreateWindowEx,WS_EX_CLIENTEDGE,addr edt,addr blank,
			WS_VISIBLE or WS_CHILDWINDOW or ES_NOHIDESEL or ES_MULTILINE,
	        Left2,Top,Wide2,Ht,hWin,CtlGp,temp1,NULL
	inv SendMessage,eax,WM_SETFONT,hFnt,TRUE
	add CtlGp,1000
	
	inv CreateWindowEx,WS_EX_CLIENTEDGE,addr edt,soff(" "),
			WS_VISIBLE or WS_CHILDWINDOW or ES_AUTOHSCROLL or ES_NOHIDESEL,
			Left3,Top,Wide3,Ht,hWin,CtlGp,temp1,NULL
	inv SendMessage,eax,WM_SETFONT,hFnt,TRUE
	add CtlGp,1000
	
	inv CreateWindowEx,WS_EX_CLIENTEDGE,addr edt,soff(" "),
			WS_VISIBLE or WS_CHILDWINDOW or ES_AUTOHSCROLL or ES_NOHIDESEL,
			Left4,Top,Wide4,Ht,hWin,CtlGp,temp1,NULL
	inv SendMessage,eax,WM_SETFONT,hFnt,TRUE
	add CtlGp,1000
	
	inv CreateWindowEx,WS_EX_CLIENTEDGE,addr edt,soff(" "),
			WS_VISIBLE or WS_CHILDWINDOW or ES_AUTOHSCROLL or ES_NOHIDESEL,
			Left5,Top,Wide5,Ht,hWin,CtlGp,temp1,NULL
	inv SendMessage,eax,WM_SETFONT,hFnt,TRUE

	mov eax,TDel	; set up for next group
	add Top,eax

	ret
MakeControls EndP

.data
ctsfmt db "Test %i",0
.code

CallTableSetup:  ; call table setup, save offsets of tests, and also add controls to dialog
	mov TestNum,1	; step through ids 1-MaxTests
	mov ebx,offset CallTable
	num=0
	Repeat MaxTests
		num=num+1
		arg CatStr <Doit>, %num		;; construct  Doit1, Doit2, etc.
		if (opattr(arg)) and 01y	;; if it is a label
			mov [ebx],offset arg
			pusha	;; save everything while we add controls, etc.
			inv wsprintf,addr buff,addr ctsfmt,TestNum   ; get button caption
			call MakeControls
			mov eax,offset arg
			call eax  		; call for first time just to get description
			popa
		endif
		add ebx,4		;; set up for next store address
		add TestNum,1		;; set up for next ID
	endm	
	
	ret

SetDesc proc	; enter with Description Offset in ebx
	pusha		; save users setup if any
	push ebx	
	mov eax,TestNum
	add eax,3000		; get the id of the description box
	GetHandle eax,htemp
	pop	ebx		; get back Description offset
	invoke SendMessage,htemp,WM_SETTEXT,0,ebx
	popa
	ret
SetDesc EndP

WrapUp proc
	sub eax,[StartingCycle]	; get result in EDX:EAX
	sbb edx,[StartingCycle+4]
	mov Result,eax
	mov ecx,TimesToLoop		; divide by number of times through the loop
	div ecx				; result of division in EAX, remainder in EDX
	mov Average,eax
	invoke wsprintf,addr buff,soff("%i"),Result
	mov eax,TestNum
	add eax,4000		; Clock cycles
	GetHandle eax,htemp
	invoke SendMessage,htemp,WM_SETTEXT,0,addr buff
	invoke wsprintf,addr buff,soff("%i"),Average
	mov eax,TestNum
	add eax,5000		; Average cycles
	GetHandle eax,htemp
	invoke SendMessage,htemp,WM_SETTEXT,0,addr buff
	ret
WrapUp EndP

end start
